#include "stdafx.h"
#include "CommonFun.h"
#include <stdio.h>

static char s_cChineseCharMin = (char)0xA1;
static char s_cChineseCharMax = (char)0xF7;

CString g_strLocalSaveDirectory;

//  ЧIPַ>0, :
//  ಥַ:2
//  :3
//  ͨIP:1
int IsValidIP(const char* _cIP)
{
	if (!_cIP)
		return 0;

    int i, i1, i2, i3, i4=0;
	char ct = '\0';
    unsigned long uIP=0;
    if(sscanf_s(_cIP, "%03d.%03d.%03d.%d%c", &i1, &i2, &i3, &i4, &ct) != 4)
        return 0;
    if( ((0 <= i1) && (i1 <= 255)) &&
        ((0 <= i2) && (i2 <= 255)) &&
        ((0 <= i3) && (i3 <= 255)) &&
        ((0 <= i4) && (i4 <= 255)) )
    {
        if((224 <= i1) && (i1 <= 239))
            return 2;   //Multicast

        uIP = (i1<<24) | (i2<<16) | (i3<<8) | (i4);
        i=0;
        while(((uIP & 0x01)==0) && i<32)
        {
            uIP = uIP>>1;
            i++;
        }
        while(((uIP & 0x01)==1) && i<32)
        {
            uIP = uIP>>1;
            i++;
        }
        if(i==32)
            return 3;     //Mask
        else
            return 1;     //valid ip
    }
    return 0;
}

int IsValidIP(const char* _cIP,const char* _cMask,const char* _cGateway)
{
	unsigned long ulIP = inet_addr(_cIP);
	unsigned long ulMask = inet_addr(_cMask);
	unsigned long ulGateway = inet_addr(_cGateway);
	
	if (ulIP != 0 || ulGateway != 0)
	{
		if (INADDR_NONE == ulIP || INADDR_NONE == ulMask || INADDR_NONE == ulGateway
			||( 0 == (ulIP & 0xFF) || 0 == (ulGateway & 0xFF)))
		{
			return -1;
		}
	}

	if ((ulIP & ulMask) == (ulGateway & ulMask))
	{
		return 0;
	}
	return -1;
}

PDEVICE_INFO FindDevice( char* _pcIP,char* _pcProxy,char* _pcID,int* _piLogonID)
{
	return CLS_DeviceManager::Instance()->FindDevice(_pcIP,_pcProxy,_pcID,_piLogonID);
}

PDEVICE_INFO FindDevice( int _iLogonID )
{
	return CLS_DeviceManager::Instance()->FindDevice(_iLogonID);
}

PDEVICE_INFO AddDevice( int _iLogonID )
{
	return CLS_DeviceManager::Instance()->AddDevice(_iLogonID);
}

PDEVICE_INFO RemoveDevice( int _iLogonID )
{
	return CLS_DeviceManager::Instance()->RemoveDevice(_iLogonID);
}

PDEVICE_INFO RemoveDevice( char* _pcIP,char* _pcProxy,char* _pcID,int* _piLogonID /*= NULL*/ )
{
	return CLS_DeviceManager::Instance()->RemoveDevice(_pcIP,_pcProxy,_pcID,_piLogonID);
}

PCHANNEL_INFO FindChannel( int _iLogonID,int _iChannelNo,int _iStreamNo,unsigned int* _puConnID)
{
	return CLS_DeviceManager::Instance()->FindChannel(_iLogonID,_iChannelNo,_iStreamNo,_puConnID);
}

PCHANNEL_INFO FindChannel( unsigned int _uConnID )
{
	return CLS_DeviceManager::Instance()->FindChannel(_uConnID);
}

PCHANNEL_INFO AddChannel( unsigned int _uConnID )
{
	return CLS_DeviceManager::Instance()->AddChannel(_uConnID);
}

PCHANNEL_INFO RemoveChannel( unsigned int _uConnID )
{
	return CLS_DeviceManager::Instance()->RemoveChannel(_uConnID);
}

PCHANNEL_INFO RemoveChannel( int _iLogonID,int _iChannelNo,int _iStreamNo,unsigned int* _puConnID /*= NULL*/ )
{
	return CLS_DeviceManager::Instance()->RemoveChannel(_iLogonID,_iChannelNo,_iStreamNo,_puConnID);
}
void SetLogCtrl( CListCtrl* _plvLog )
{
	CLS_LogManager::Instance()->SetListCtrl(_plvLog);
}

int SetLogFileName( char* _pcFileName,int _iLen )
{
	if (_iLen <= 0)
	{
		_iLen = (int)strlen(_pcFileName);
	}
	return CLS_LogManager::Instance()->SetFileName(_pcFileName,_iLen);
}

int SetLogCaps( unsigned int _uRemove,unsigned int _uAdd )
{
	return CLS_LogManager::Instance()->SetLogCaps(_uRemove,_uAdd);
}

unsigned int GetLogCaps()
{
	return CLS_LogManager::Instance()->GetLogCaps();
}

void AddLog( int _iLogType,const char* _pcDevFmt,const char* _pcLogFmt, ... )
{
	int iLastError = GetLastError();
	if (NULL == _pcDevFmt)
	{
		_pcDevFmt = "";
	}
	if (NULL == _pcLogFmt)
	{
		_pcLogFmt = "";
	}

	char cDevInfo[2048] = {0};
	char cFormat[1024] = {0};
	char cSplit[5] = {28,29,30,31};
	
	sprintf_s(cFormat,sizeof(cFormat),"%s%s%s",_pcDevFmt,cSplit,_pcLogFmt);
	va_list vlLog;
	va_start(vlLog, _pcLogFmt);
	vsprintf_s(cDevInfo, cFormat, vlLog);
	va_end(vlLog);	
	char* pcLogInfo = strstr(cDevInfo,cSplit);
	if (pcLogInfo)
	{
		memset(pcLogInfo,0,strlen(cSplit));
		pcLogInfo += strlen(cSplit);
	}
	else
	{
		pcLogInfo = "";
	}

	CLS_LogManager::Instance()->AddLog(_iLogType,cDevInfo,pcLogInfo,iLastError);
}

void DestroyManager()
{
	CLS_DeviceManager::Destroy();
	CLS_LanguageManager::Destroy();
	CLS_LogManager::Destroy();
	CLS_MessageManager::Destroy();
}


int InsertItem( CTabCtrl& _TabCtrl,int _iItem,LPCTSTR _strItem )
{
	int iCount = _TabCtrl.GetItemCount();
	if (_iItem >= 0 && _iItem < iCount)
	{
		TCITEM tcItem = {0};
		tcItem.mask = TCIF_TEXT;
		tcItem.pszText = (LPSTR)_strItem;
		_TabCtrl.SetItem(_iItem,&tcItem);
	}
	else
	{
		_TabCtrl.InsertItem(_iItem,_strItem);
	}

	return 0;
}

int InsertItem( CTabCtrl& _TabCtrl,int _iItem,unsigned int _uIDResource )
{
	return InsertItem(_TabCtrl,_iItem,GetTextEx(_uIDResource));
}


HTREEITEM InsertItem( CTreeCtrl& _TreeCtrl,LPCTSTR _strItem,DWORD_PTR _dwData,HTREEITEM _hParent /*= TVI_ROOT*/ )
{
	DWORD_PTR dwData = 0;
	HTREEITEM hItem = _TreeCtrl.GetChildItem(_hParent);
	while(hItem)
	{
		dwData = _TreeCtrl.GetItemData(hItem);
		if (dwData == _dwData)
		{
			_TreeCtrl.SetItemText(hItem,_strItem);
			return hItem;
		}
		hItem = _TreeCtrl.GetNextSiblingItem(hItem);
	}

	hItem = _TreeCtrl.InsertItem(_strItem,_hParent);
	_TreeCtrl.SetItemData(hItem,_dwData);
	return hItem;
}

HTREEITEM InsertItem( CTreeCtrl& _TreeCtrl,unsigned int _uIDResource,DWORD_PTR _dwData,HTREEITEM _hParent /*= TVI_ROOT*/ )
{
	return InsertItem(_TreeCtrl,GetTextEx(_uIDResource),_dwData,_hParent);
}

int InsertColumn( CListCtrl& _ListCtrl,int _iColumn,LPCTSTR _strColumn, int _iFormat /*= LVCFMT_LEFT*/,int _iWidth /*= -1*/,int _iSubItem /*= -1*/ )
{
	CHeaderCtrl* pHeader = _ListCtrl.GetHeaderCtrl();
	if (pHeader)
	{
		int iCount = pHeader->GetItemCount();
		if (_iColumn >= 0 && _iColumn < iCount)
		{
			HDITEM hdItem = {0};
			hdItem.mask = HDI_TEXT;
			hdItem.pszText = (LPSTR)_strColumn;
			pHeader->SetItem(_iColumn,&hdItem);
			return 0;
		}
	}

	_ListCtrl.InsertColumn(_iColumn,_strColumn,_iFormat,_iWidth,_iSubItem);
	return 0;
}

int InsertColumn( CListCtrl& _ListCtrl,int _iColumn,unsigned int _uIDResource, int _iFormat /*= LVCFMT_LEFT*/,int _iWidth /*= -1*/,int _iSubItem /*= -1*/ )
{
	return InsertColumn(_ListCtrl,_iColumn,GetTextEx(_uIDResource),_iFormat,_iWidth,_iSubItem);
}

int InsertString( CComboBox& _ComboBox,int _iIndex,LPCTSTR _strItem )
{
	int iItem = _ComboBox.GetCurSel();
	_ComboBox.DeleteString(_iIndex);
	_ComboBox.InsertString(_iIndex,_strItem);
	_ComboBox.SetCurSel(iItem);

	return 0;
}

int InsertString( CComboBox& _ComboBox,int _iIndex,unsigned int _uIDResource )
{
	return InsertString(_ComboBox,_iIndex,GetTextEx(_uIDResource));
}

bool IsDVR(const int _iProductModel)
{
	return ((_iProductModel & 0x100) == 0x100);
}

CString IntToString( int _iData )
{
	CString strData;
	strData.Format(_T("%d"),_iData);
	return strData;
}

string IntToStr( int _iValue )
{
	char pcValue[32] = {0};
	sprintf_s(pcValue,"%d",_iValue);
	string strTemp = pcValue;
	return strTemp;
}

int SetLocalSaveDirectory( CString _strPath )
{
	CreateDirectory(_strPath,NULL);
	g_strLocalSaveDirectory = _strPath;
	return 0;
}

CString GetLocalSaveDirectory()
{
	return g_strLocalSaveDirectory;
}

CString Bytes2HexString( unsigned char* _pcSrc,int _iSrcLen )
{
	CString strHex;
	for (int i = 0; i < _iSrcLen; ++i)
	{
		strHex.AppendFormat(_T("%02X "),_pcSrc[i]);
	}
	return strHex.Trim();
}

bool Inner_SafeCloseFile(FILE** _ppFile)
{
	if (_ppFile == NULL || *_ppFile == NULL)
		return true;

	fclose(*_ppFile);
	*_ppFile = NULL;
	return true;
}

//ֻڱĺƴ˷ֵʱ
//intsert***(0, IntToCString(**))CString str = IntToCString(**)
CString IntToCString(int _iPara, CString *_pCstr/* = NULL*/)
{
	if (_pCstr == NULL)
	{
		CString strPara;
		strPara.Format(_T("%d"), _iPara);
		return strPara;
	}
	else
	{
		_pCstr->Format(_T("%d"), _iPara);
		return *_pCstr;
	}
}

//㷨2 Ƿڶڲ  Ĭı _iPtSumĬΪ4
//_ptCur ǰ㣬_ptPolygon ε꣬ ε
// жϷ ӵǰ루00һߣȻÿжǷн㣬ͳһٸ㣬żⲿڲ
bool IfPointInPolygon(POINT _ptCur, POINT *_ptPolygon, int _iPtSum)
{
	if(_iPtSum < 1)
		return false;
	POINT pt = {0};
	int iPtSum = 0;
	for(int i = 0; i< _iPtSum - 1; i++)   //жϵǰ루00ıε߹ж
	{
		if(IfHaveInterSection(_ptCur, pt, _ptPolygon[i], _ptPolygon[i+1]))
			iPtSum++;
	}
	//жϵǰ루00ıεһǷн
	if(IfHaveInterSection(_ptCur, pt, *_ptPolygon, *(_ptPolygon+ _iPtSum - 1)))
		iPtSum++;

	if(iPtSum%2)
	{
		//trace("ڲ\n");
		return true;
	}
	else
	{
		//trace("ⲿ\n");
		return false;
	}
}

//㷨1 жǷн㺯
bool IfHaveInterSection(POINT _ptLine1Start, POINT _ptLine1End, POINT _ptLine2Start, POINT _ptLine2End)     //wxl 2011-11-22
{
	double iL1SX = _ptLine1Start.x;
	double iL1SY = _ptLine1Start.y;

	double iL2SX = _ptLine2Start.x;
	double iL2SY = _ptLine2Start.y;

	double iL1EX = _ptLine1End.x;
	double iL1EY = _ptLine1End.y;

	double iL2EX = _ptLine2End.x;
	double iL2EY = _ptLine2End.y;
	double fDiv = 0.0;
	double fInterSX = 0.0;           //н x
	double fInterSY = 0.0;           //н y

	fDiv = (iL1SX -iL1EX)*(iL2SY -iL2EY) -(iL2SX -iL2EX)*(iL1SY - iL1EY);
	if(fDiv == 0)
	{
		return false;
	}
	else
	{
		fInterSX = ((iL2SX-iL2EX)*(iL1SX*iL1EY -iL1EX*iL1SY)-(iL1SX-iL1EX)*(iL2SX*iL2EY - iL2EX*iL2SY))/fDiv;
		fInterSY = ((iL2EX*iL2SY -iL2SX*iL2EY)*(iL1SY-iL1EY)-(iL2SY-iL2EY)*(iL1EX*iL1SY-iL1SX*iL1EY))/fDiv;

		if (fInterSX < max(min(iL1SX,iL1EX),min(iL2SX,iL2EX)) || fInterSX > min(max(iL1SX,iL1EX),max(iL2SX,iL2EX)))
		{
			return false;
		}
		else if (fInterSY < max(min(iL1SY,iL1EY),min(iL2SY,iL2EY)) || fInterSY > min(max(iL1SY,iL1EY),max(iL2SY,iL2EY)))
		{
			return false;
		}
		else
		{
			return true;      //н
		}
	}
}

//㷨 жǷཻ㷨Ҫжı
bool IfPolygonIntersect(POINT *_ptPolygon1, int _iPoly1, POINT *_ptPolygon2, int _iPoly2)
{
	POINT ptPolygon1[5] = {0};
	memcpy(ptPolygon1, _ptPolygon1, _iPoly1 * sizeof(POINT));
	ptPolygon1[_iPoly1] =  _ptPolygon1[0];

	POINT ptPolygon2[5] = {0};
	memcpy(ptPolygon2, _ptPolygon2, _iPoly2 * sizeof(POINT));
	ptPolygon2[_iPoly2] =  _ptPolygon2[0];

	for(int i = 0; i < _iPoly1; i++)
	{
		for(int j = 0; j < _iPoly2; j++)
		{
			if(IfHaveInterSection(*(ptPolygon1+i), *(ptPolygon1+i+1), *(ptPolygon2+j), *(ptPolygon2+j+1)))
				return true;
		}
	}
	return false;
}

//㷨 ཻĶΣжǷ
bool IfPolygonInPolygon(POINT *_ptPolygon1, int _iPoly1, POINT *_ptPolygon2, int _iPoly2)
{
	if(IfPointInPolygon(_ptPolygon1[0], _ptPolygon2, _iPoly2))
	{
		return true;
	}
	if(IfPointInPolygon(_ptPolygon2[0], _ptPolygon1, _iPoly2))
	{
		return true;
	}
	return false;
}

void* MallocMsgMemory(int _iSize)
{
	return CLS_MessageManager::Instance()->MallocMemory(_iSize);
}

void FreeMsgMemory( void* _pMemory )
{
	CLS_MessageManager::Instance()->FreeMemory(_pMemory);
}

int SplitStringToArray(const string &_strStingSource, const string &_strSplitChar,
    string *_strArray,  int _iArraySize, const int _numberOfElements)
/*  _astrStingSource:Դַ
          _astrSplitCharַָ "/""@"ȣ
          _astrArray    ֵַ飬ֳֵַ
    ܣŸֳַ
*/
{
    int iTempCount=0;
    int iTempPos=0;  //ַָ    //modify by lpy;
    int iTempPos1=0; //¼һַ׵ַ
    int iTempPos2=0; //¼һַβַ

	int iTempStrLen = (int)_strStingSource.length();
    
    if (iTempStrLen > _numberOfElements) //wxl 2011-12-21 ֹڴԽ
    {
        iTempStrLen = _numberOfElements;
    }
    while (iTempPos<=iTempStrLen && (iTempCount < _iArraySize -1))
    {
		string strTemp = _strStingSource.substr(iTempPos,1) ; 
        if (strTemp.compare(_strSplitChar) == 0)
        {
            if (iTempPos1==0)
            {
                iTempPos1=iTempPos+1;
                if(iTempPos != 0)
                {
                    _strArray[iTempCount]=_strStingSource.substr(0, iTempPos);
                    iTempCount++;
                }
            }
            else if (iTempPos2==0)
            {
                iTempPos2=iTempPos+1;
                _strArray[iTempCount]=_strStingSource.substr(iTempPos1,iTempPos2-iTempPos1-1);
                iTempCount++;
                iTempPos1=iTempPos2;
                iTempPos2=0;
            }
        }
        iTempPos++;
    }
		_strArray[iTempCount]=_strStingSource.substr(iTempPos1,iTempPos-iTempPos1);
    return iTempCount+1;
}

CString GetText(UINT _uiID)
{
	CString strBuffer;
	strBuffer.LoadString(_uiID);
	return strBuffer;
}

CString ExtractFilePath()
{
	char fileNewPath[MAX_PATH+1]= {0};
	char *p = NULL;
	GetModuleFileName(NULL, fileNewPath, sizeof(fileNewPath)); //ȡǰִļ
	p=strrchr(fileNewPath, '\\');   
	*(p + 1)='\0';
	return CString(fileNewPath);
}

int GetCboSel(CComboBox* _pComboBox, int _iItemData)
{
	int iResult = -1;
	if (NULL == _pComboBox)
	{
		return iResult;
	}

	int iMaxIndex = _pComboBox->GetCount();
	for (int iTempIndex = 0; iTempIndex < iMaxIndex; iTempIndex++)
	{
		if (_iItemData == _pComboBox->GetItemData(iTempIndex))
		{
			iResult = iTempIndex;
			break;
		}
	}

	return iResult;
}

int FillStringBufferGb2312(char* _pcStringBuffer, int _iStringLen, char* _pcSrc, int _iSrcLen)
{
	if (NULL == _pcStringBuffer || NULL == _pcSrc)
	{
		return -1;
	}

	int iCopyLen = 0;
	while (iCopyLen <= _iSrcLen)
	{
		int iCharLen = 1;
		if (_pcSrc[iCopyLen] >= s_cChineseCharMin && _pcSrc[iCopyLen] <= s_cChineseCharMax)
		{
			iCharLen = 2;
		}

		if (iCopyLen + iCharLen >= _iStringLen)
		{
			_pcStringBuffer[iCopyLen] = '\0';
			break;
		}

		if (iCopyLen + iCharLen > _iSrcLen)
		{
			_pcStringBuffer[iCopyLen] = '\0';
			break;
		}

		memcpy(_pcStringBuffer + iCopyLen, _pcSrc+iCopyLen, iCharLen);
		iCopyLen += iCharLen;
	}
	return  iCopyLen;
}

void SetListCtrlColumn(CListCtrl& _lstListCtrl, int _iIndex, CString _cstrColumnName)
{
	CHeaderCtrl *pHead = _lstListCtrl.GetHeaderCtrl();    
	if(NULL == pHead || NULL == pHead->GetSafeHwnd())    
	{    
		return;
	}  

	TCHAR szBuf[MAX_LIST_COLUMN_NAME_LEN + 1] = {0};    
	HDITEM hdItem ={0};    
	hdItem.mask = HDI_TEXT; //ȡַ     
	hdItem.pszText = szBuf; //ַ     
	hdItem.cchTextMax = MAX_LIST_COLUMN_NAME_LEN; //С     
	hdItem.pszText = _cstrColumnName.GetBuffer(0); //ַ     
	pHead->SetItem(_iIndex, &hdItem); //ͷ   
}
