// ActivePage.cpp : implementation file
//

#include "stdafx.h"
#include "NetClientDemo.h"
#include "ActivePage.h"
#include "../LogonActive.h"


// CLS_ActivePage dialog

IMPLEMENT_DYNAMIC(CLS_ActivePage, CDialog)

CLS_ActivePage::CLS_ActivePage(CWnd* pParent /*=NULL*/)
	: CLS_BasePage(CLS_ActivePage::IDD, pParent)
{
	CString strFile;
	strFile.Format("%s%s", ExtractFilePath(), "DSMInfo.Ini");
	m_iniFile.SetFileName(strFile.GetString());
}

CLS_ActivePage::~CLS_ActivePage()
{
}

void CLS_ActivePage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_MNG_ACT_LOCA_IP, m_edtLocalIp);
	DDX_Control(pDX, IDC_EDIT_MNG_ACT_PORT, m_edtLocalPort);
	DDX_Control(pDX, IDC_EDIT_MNG_ACT_DSM_IP, m_edtDsmIp);
	DDX_Control(pDX, IDC_EDIT_MNG_ACT_DSM_PORT, m_edtDsmPort);
	DDX_Control(pDX, IDC_EDIT_MNG_ACT_DSM_BAK_IP, m_edtBakDsmIp);
	DDX_Control(pDX, IDC_EDIT_MNG_ACT_DSM_BAK_PORT, m_edtBakDsmPort);
	DDX_Control(pDX, IDC_LIST_ACTIVE_REGISTER_LIST, m_lstRegisterList);
	DDX_Control(pDX, IDC_EDIT_ACTIVE_LISTEN_PORT, m_edtActivePort);
}


BEGIN_MESSAGE_MAP(CLS_ActivePage, CDialog)
	ON_BN_CLICKED(IDC_BUTTONMNG_ACTIVE_SET, &CLS_ActivePage::OnBnClickedButtonmngActiveSet)
	ON_BN_CLICKED(IDC_BUTTON_REFRESH_REGISTER_LIST, &CLS_ActivePage::OnBnClickedButtonRefreshRegisterList)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_ACTIVE_REGISTER_LIST, &CLS_ActivePage::OnNMDblclkListActiveRegisterList)
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()


// CLS_ActivePage message handlers

BOOL CLS_ActivePage::OnInitDialog()
{
	CLS_BasePage::OnInitDialog();

	// TODO:  Add extra initialization here
	m_edtLocalIp.SetLimitText(LEN_64);
	m_edtLocalPort.SetLimitText(LEN_32);
	m_edtDsmIp.SetLimitText(LEN_64);
	m_edtDsmPort.SetLimitText(LEN_32);
	m_edtBakDsmIp.SetLimitText(LEN_64);
	m_edtBakDsmPort.SetLimitText(LEN_32);

	CString szInfo;
	szInfo = m_iniFile.ReadString("Directory", "LocalIP", "127.0.0.1");
	SetDlgItemText(IDC_EDIT_MNG_ACT_LOCA_IP, szInfo);
	SetDlgItemInt(IDC_EDIT_MNG_ACT_PORT,m_iniFile.ReadInteger("Directory","LocalPort", 6004));

	szInfo = m_iniFile.ReadString("Directory", "MainDirectoryIP", "127.0.0.1");
	SetDlgItemText(IDC_EDIT_MNG_ACT_DSM_IP, szInfo);
	SetDlgItemInt(IDC_EDIT_MNG_ACT_DSM_PORT,m_iniFile.ReadInteger("Directory","MainDirectoryPort", 6004));

	szInfo = m_iniFile.ReadString("Directory", "SubDirectoryIP", "127.0.0.1");
	SetDlgItemText(IDC_EDIT_MNG_ACT_DSM_BAK_IP, szInfo);
	SetDlgItemInt(IDC_EDIT_MNG_ACT_DSM_BAK_PORT,m_iniFile.ReadInteger("Directory","SubDirectoryPort", 6004));

	m_edtActivePort.SetLimitText(LEN_16);
	SetDlgItemInt(IDC_EDIT_ACTIVE_LISTEN_PORT, 6005);
	m_lstRegisterList.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
	UI_UpdateDialogText();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CLS_ActivePage::OnLanguageChanged( int _iLanguage )
{
	UI_UpdateDialogText();
}

void CLS_ActivePage::UI_UpdateDialogText()
{
	SetDlgItemTextEx(IDC_STATIC_MNG_ACTIVE_LOCAL_IP, IDS_MNG_LOCAL_IP);
	SetDlgItemTextEx(IDC_STATIC_MNG_ACTIVE_LOCAL_PORT, IDS_MNG_LOCAL_POTR);
	SetDlgItemTextEx(IDC_STATIC_MNG_ACT_DSM_IP, IDS_MNG_DSM_IP);
	SetDlgItemTextEx(IDC_STATIC_MNG_ACT_DSM_PORT, IDS_MNG_DSM_PORT);
	SetDlgItemTextEx(IDC_STATIC_MNG_ACT_BAK_DSM_IP, IDS_MNG_BAK_DSM_IP);
	SetDlgItemTextEx(IDC_STATIC_MNG_ACT_DSM_BAK_PORT,IDS_MNG_BAK_DSM_PORT);
	SetDlgItemTextEx(IDC_BUTTONMNG_ACTIVE_SET, IDS_SET);
	SetDlgItemTextEx(IDC_BUTTON_REFRESH_REGISTER_LIST, IDS_MNG_ADMIN_REFRESH);
	SetDlgItemTextEx(IDC_STATIC_ACTIVE_LISTEN_PORT, IDS_ACTIVE_LISTEN_PORT);

	InsertColumn(m_lstRegisterList, 0, IDS_MNG_ADMIN_FACTORY_ID, LVCFMT_LEFT, 360);
	InsertColumn(m_lstRegisterList, 1, IDS_CONFIG_WIFI_STATE, LVCFMT_LEFT, 160);
}

void CLS_ActivePage::OnBnClickedButtonmngActiveSet()
{
	int iActivePort = 0;
	iActivePort = GetDlgItemInt(IDC_EDIT_ACTIVE_LISTEN_PORT);
	int iRet = NetClient_SetPort( iActivePort, iActivePort);
	if (RET_SUCCESS == iRet)
	{
		AddLog(LOG_TYPE_SUCC, "", "NetClient_SetPort (%d, %d)", iActivePort, iActivePort);
	}
	else
	{
		AddLog(LOG_TYPE_FAIL, "", "NetClient_SetPort (%d, %d)", iActivePort, iActivePort);
	}
}

void CLS_ActivePage::OnBnClickedButtonRefreshRegisterList()
{
	UI_UpdataRegisterInfo();
}

void CLS_ActivePage::OnNMDblclkListActiveRegisterList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	DEVICE_INFO tDevInit = {0};
	m_lstRegisterList.GetItemText(pNMItemActivate->iItem, 0, tDevInit.cID, LEN_32);
	strcpy_s(tDevInit.cUserName,sizeof(tDevInit.cUserName),"Admin");
	strcpy_s(tDevInit.cPassword,sizeof(tDevInit.cPassword),"1111");

	CLS_LogonActive clsLogonActive(&tDevInit);
	if(IDOK != clsLogonActive.DoModal())
	{
		return;
	}

	int iOldLogonID = -1;
	PDEVICE_INFO ptDevLogon = clsLogonActive.GetDeviceInfo();
	PDEVICE_INFO ptDevFind = FindDevice(ptDevLogon->cIP, ptDevLogon->cProxy, ptDevLogon->cID, &iOldLogonID);
	if (NULL != ptDevFind)
	{
		if(LOGON_SUCCESS == NetClient_GetLogonStatus(iOldLogonID))
		{
			AddLog(LOG_TYPE_MSG,"","FindDevice(%s,%s) device already exist!"
				,ptDevFind->cIP, ptDevFind->cID);
			return;
		}
	}

	LogonActiveServer tLogonPara = {0};
	tLogonPara.iSize = sizeof(LogonActiveServer);
	strcpy_s(tLogonPara.cUserName, sizeof(tLogonPara.cUserName), ptDevLogon->cUserName);
	strcpy_s(tLogonPara.cUserPwd, sizeof(tLogonPara.cUserPwd), ptDevLogon->cPassword);
	strcpy_s(tLogonPara.cProductID, sizeof(tLogonPara.cProductID), ptDevLogon->cID);
	int iLogonID = NetClient_Logon_V4(SERVER_ACTIVE, &tLogonPara, sizeof(LogonActiveServer));
	if (iLogonID >= 0)
	{
		AddLog(LOG_TYPE_SUCC,ptDevLogon->cIP,"(%d)NetClient_Logon_V4",iLogonID);
		if (NULL != ptDevFind)
		{
			return;
		}
		PDEVICE_INFO ptDevNew = AddDevice(iLogonID);
		if (NULL != ptDevNew)
		{
			memcpy_s(ptDevNew, sizeof(DEVICE_INFO), ptDevLogon, sizeof(DEVICE_INFO));
			ptDevNew->hItem = NULL;
			ptDevNew->uiInterTalkID  = -1;
		}
		else
		{
			AddLog(LOG_TYPE_MSG,"","AddDevice(%d) Can not add device", iLogonID);
		}
	}
	else
	{
		AddLog(LOG_TYPE_FAIL,ptDevLogon->cIP,"NetClient_Logon_V4(%s)",ptDevLogon->cID);
	}

	*pResult = 0;
}

void CLS_ActivePage::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CLS_BasePage::OnShowWindow(bShow, nStatus);

	// TODO: Add your message handler code here
	UI_UpdataRegisterInfo();
	
}

void CLS_ActivePage::UI_UpdataRegisterInfo()
{
	m_lstRegisterList.DeleteAllItems();

	char* pcDevList = NULL;
	int iRegisterCount = 0;
	NetClient_GetDsmRegstierInfo(DSM_CMD_GET_REGISTER_COUNT, &iRegisterCount, sizeof(int));
	if (iRegisterCount <= 0)
	{
		AddLog(LOG_TYPE_MSG, "", "iRegisterCount(%d) <= 0", iRegisterCount);
		goto END;
	}

	pcDevList = new char[iRegisterCount * LEN_32];
	if (NULL == pcDevList)
	{
		goto END;
	}
	NetClient_GetDsmRegstierInfo(DSM_CMD_GET_REGISTER_DEVLIST, pcDevList, iRegisterCount * LEN_32);

	for (int iItem = 0; iItem < iRegisterCount; ++iItem)
	{
		char cFactoryID[LEN_32] = {0};
		memcpy(cFactoryID, pcDevList + iItem * LEN_32, LEN_32);
		m_lstRegisterList.InsertItem(iItem, cFactoryID);

		DsmOnline tOnline = {0};
		tOnline.iSize = sizeof(DsmOnline);
		strncpy_s(tOnline.cProductID, LEN_32, cFactoryID, LEN_32);
		NetClient_GetDsmRegstierInfo(DSM_CMD_GET_ONLINE_STATE, &tOnline, sizeof(DsmOnline));
		if (DSM_STATE_ONLINE == tOnline.iOnline)
		{
			m_lstRegisterList.SetItemText(iItem, 1, GetTextEx(IDS_CONFIG_WIFI_ONLINE));
		}
		else
		{
			m_lstRegisterList.SetItemText(iItem, 1, GetTextEx(IDS_CONFIG_WIFI_OFFLINE));
		}	
	}

END:
	if (NULL != pcDevList)
	{
		delete []pcDevList;
		pcDevList = NULL;
	}
}
