//---------------------------------------------------------------------------

#include "stdafx.h"
#include "libNVSSDK.h"

//---------------------------------------------------------------------------

static HINSTANCE g_hLibNvssdk = NULL;

pNetClient_Startup NetClient_Startup = NULL;
pNetClient_SetPort NetClient_SetPort = NULL;
pNetClient_SetMSGHandle NetClient_SetMSGHandle = NULL;
pNetClient_Logon NetClient_Logon = NULL;
pNetClient_Logoff NetClient_Logoff = NULL;
pNetClient_StartRecv NetClient_StartRecv = NULL;
pNetClient_StartCaptureData NetClient_StartCaptureData = NULL;
pNetClient_GetVideoHeader NetClient_GetVideoHeader = NULL;
pNetClient_StopRecv NetClient_StopRecv = NULL;
pNetClient_GetLogonStatus NetClient_GetLogonStatus = NULL;
pNetClient_StartPlay NetClient_StartPlay = NULL;
pNetClient_CaptureBmpPic NetClient_CaptureBmpPic = NULL;
pNetClient_GetPlayingStatus NetClient_GetPlayingStatus = NULL;


int LoadNVSSDK()
{
    if(NULL != g_hLibNvssdk)
        return -1;

    g_hLibNvssdk = LoadLibrary("NVSSDK.dll");
    if(NULL == g_hLibNvssdk)
    {
        DWORD dwError = GetLastError();
        return -1;
    }

    NetClient_Startup = (pNetClient_Startup)GetProcAddress(g_hLibNvssdk,"NetClient_Startup");
    NetClient_SetPort = (pNetClient_SetPort)GetProcAddress(g_hLibNvssdk,"NetClient_SetPort");
    NetClient_SetMSGHandle = (pNetClient_SetMSGHandle)GetProcAddress(g_hLibNvssdk,"NetClient_SetMSGHandle");
    NetClient_Logon = (pNetClient_Logon)GetProcAddress(g_hLibNvssdk,"NetClient_Logon");
	NetClient_Logoff = (pNetClient_Logoff)GetProcAddress(g_hLibNvssdk,"NetClient_Logoff");
	NetClient_StartRecv = (pNetClient_StartRecv)GetProcAddress(g_hLibNvssdk,"NetClient_StartRecv");
	NetClient_StartCaptureData = (pNetClient_StartCaptureData)GetProcAddress(g_hLibNvssdk,"NetClient_StartCaptureData");
	NetClient_GetVideoHeader = (pNetClient_GetVideoHeader)GetProcAddress(g_hLibNvssdk,"NetClient_GetVideoHeader");
	NetClient_StopRecv = (pNetClient_StopRecv)GetProcAddress(g_hLibNvssdk,"NetClient_StopRecv");
	NetClient_GetLogonStatus = (pNetClient_GetLogonStatus)GetProcAddress(g_hLibNvssdk,"NetClient_GetLogonStatus");

	NetClient_StartPlay = (pNetClient_StartPlay)GetProcAddress(g_hLibNvssdk,"NetClient_StartPlay");
	NetClient_CaptureBmpPic = (pNetClient_CaptureBmpPic)GetProcAddress(g_hLibNvssdk,"NetClient_CaptureBmpPic");
	NetClient_GetPlayingStatus = (pNetClient_GetPlayingStatus)GetProcAddress(g_hLibNvssdk,"NetClient_GetPlayingStatus");

    return 0;
}


int FreeNVSSDK()
{
    if(g_hLibNvssdk)
    {
        FreeLibrary(g_hLibNvssdk);
        g_hLibNvssdk = NULL;
    }
    return 0;
}
